# Copyright (C) 2020 VMware, Inc. All rights reserved.
# -- VMware Confidential

def report_edge_mgmt_interface_stats(metric_list, profile):
    if not metric_list:
        return

    context = { "edge_nic_name": metric_list["interface_name"] }
    evt_id = feature_event_type_mappings.EDGE_HEALTH_EDGE_NIC_LINK_STATUS_DOWN_EVENT_TYPE_ID
    logger.debug("edge-mgmt-interface-status: %s, event id: %d", metric_list, evt_id)
    if metric_list["op_state"] == "up":
        Alarm(status={evt_id: {data_store['host_id']: (False, context)}}, feature="edge_health")
    else:
        Alarm(status={evt_id: {data_store['host_id']: (True, context)}}, feature="edge_health")


profile = data_store['profile']
interface_status = data_store['metrics']['nsx.edge.mgmt-interface-status']
if interface_status:
    report_edge_mgmt_interface_stats(interface_status['value'], profile)
else:
    logger.info("Failed to get interface status")
