
# Copyright (C) 2020 VMware, Inc. All rights reserved.
# -- VMware Confidential

def handle_alarm(latency_list, profile):
    EVENT_TYPE_ID =  feature_event_type_mappings.COMMUNICATION_MANAGER_CLUSTER_LATENCY_HIGH_EVENT_TYPE_ID
    FEATURE_NAME = 'communication'
    EVENT_TYPE = 'manager_cluster_latency_high'
    if not latency_list:
        return

    alarm_status = latency_list[-1]
    for node, data in alarm_status.items():
        context = {"manager_node_id" : data['src_node'],
                    "appliance_address" : data['src_ip'],
                    "remote_manager_node_id" : data['dst_node'],
                    "remote_appliance_address" : data['dst_ip']}
        logger.info("node id %s, data count %s", node, data['count'])
        if data['count'] == 5:
            Alarm(status = {EVENT_TYPE_ID : {data['dst_node_uuid'] : (True, context)}},
                  feature = FEATURE_NAME,
                  event_type = EVENT_TYPE,
                  event_type_id = EVENT_TYPE_ID)
        elif data['count'] == 0:
            Alarm(status = {EVENT_TYPE_ID : {data['dst_node_uuid'] : (False, context)}},
                  feature = FEATURE_NAME,
                  event_type = EVENT_TYPE,
                  event_type_id = EVENT_TYPE_ID)

profile = data_store['profile']
ua_node_latency_list = data_store['metrics']['nsx.ua.ua-node-latency-list']
if ua_node_latency_list:
    UaNLReport(latency_list = ua_node_latency_list['value'], profile = profile)
    handle_alarm(latency_list = ua_node_latency_list['value'], profile = profile)
else:
    logger.info("Failed to get node latency list")
